<template>
    <div class="pieItem">
        <div class="title">{{ pieData.field }}</div>
        <div style="display: flex;align-items: center;height:124px;">
            <div>
                <charts :eOption="pieOption2" v-if="pieOption2" style="height: 77px;width: 118px;" />
            </div>
            <div class="itembox i33">
                <div class="items" v-for="(item, index) in list" :key="index">
                    <div class="bc" :style="{ backgroundColor: colorList[index] }"></div>
                    <div class="itxt">
                        <span class="s1">{{ item.field }}</span>
                    </div>
                </div>
            </div>
        </div>
    </div>

</template>

<script>
import Charts from '@/components/selfCP/charts.vue';
import * as echarts from 'echarts';
import "echarts-gl";
export default {
    data() {
        return {
            pieOption2: null,
            colorList: ['#3A93FF', '#00EDFE', '#01FFFF', '#FEC087', '#F0F690', '#2A02ED', '#FB027E', '#A902FB', '#9DC5F9', '#546570', '#c4ccd3'],
            list: [],
        }
    },
    props: {
        pieData: {
            type: [Object, null],
            default: null
        }
    },
    components: {
        Charts
    },
    watch: {
        pieData: {
            handler() {
                if (this.pieData != null) {
                    this.getPieChart()
                    this.list = this.pieData.items
                }
            },
            deep: true,
            immediate: true
        }
    },
    mounted() {
    },
    methods: {
        mouseover(e) {
        },
        getPieChart() {
            const optionsData = this.pieData.items.map((r, index) => {
                return {
                    name: r.field,
                    value: Number(r.amount),
                    itemStyle: {
                        //   opacity: 0.5,
                        color: this.colorList[index],
                    },
                }
            })

            const series = this.getPie3D(optionsData, 0);// 可做为调整内环大小 0为实心圆饼图，大于0 小于1 为圆环
            series.push({
                name: "pie2d",
                type: "pie",
                label: {
                    show: false,
                    opacity: 1,
                    fontSize: 14,
                    lineHeight: 20,
                    fontSize: 14,
                    color: "#fff",
                },
                labelLine: {
                    show: false,
                    length: 30,
                    length2: 30,
                },
                startAngle: -30, //起始角度，支持范围[0, 360]。
                clockwise: false, //饼图的扇区是否是顺时针排布。上述这两项配置主要是为了对齐3d的样式
                radius: ["40%", "60%"],
                center: ["50%", "50%"],
                data: optionsData,
                itemStyle: {
                    opacity: 0,
                    resize: false,
                    // 禁用旋转
                    rotate: false
                },
            });
            // 准备待返回的配置项，把准备好的 legendData、series 传入。
            let option = {
                legend: {
                    show: false,
                },
                animation: false,
                tooltip: {
                    show: false,
                },
                backgroundColor: "transparent",
                xAxis3D: {
                    min: -1,
                    max: 1,
                },

                yAxis3D: {
                    min: -1,
                    max: 1,
                },
                zAxis3D: {
                    min: -1,
                    max: 1,
                },
                grid3D: {
                    show: false,
                    boxHeight: 3,
                    //top: '30%',
                    left: '4%',
                    bottom: "60%",
                    // environment: "rgba(255,255,255,0)",
                    viewControl: {
                        rotateMouseButton: 'middle',
                        rotate: false,
                        distance: 220,
                        zoomSensitivity: false,
                        alpha: 25,
                        beta: 10,
                        roam: false,
                        autoRotate: false, // 自动旋转
                    },
                },
                series: series,
            };
            this.pieOption2 = option
        },
        getParametricEquation(
            startRatio,
            endRatio,
            isSelected,
            isHovered,
            k,
            height,
            i
        ) {
            // 计算
            let midRatio = (startRatio + endRatio) / 2;

            let startRadian = startRatio * Math.PI * 2;
            let endRadian = endRatio * Math.PI * 2;
            let midRadian = midRatio * Math.PI * 2;

            // 如果只有一个扇形，则不实现选中效果。
            if (startRatio === 0 && endRatio === 1) {
                isSelected = false;
            }

            // 通过扇形内径/外径的值，换算出辅助参数 k（默认值 1/3）
            k = typeof k !== "undefined" ? k : 1 / 3;

            // 计算选中效果分别在 x 轴、y 轴方向上的位移（未选中，则位移均为 0）
            let offsetX = isSelected ? Math.cos(midRadian) * 0.1 : 0;
            let offsetY = isSelected ? Math.sin(midRadian) * 0.1 : 0;
            let offsetZ = i == 1 ? 2 : 0;
            // 计算高亮效果的放大比例（未高亮，则比例为 1）
            let hoverRate = isHovered ? 1.05 : 1;

            // 返回曲面参数方程
            return {
                u: {
                    min: -Math.PI,
                    max: Math.PI * 3,
                    step: Math.PI / 32,
                },

                v: {
                    min: 0,
                    max: Math.PI * 2,
                    step: Math.PI / 20,
                },

                x: function (u, v) {
                    if (u < startRadian) {
                        return (
                            offsetX +
                            Math.cos(startRadian) * (1 + Math.cos(v) * k) * hoverRate
                        );
                    }
                    if (u > endRadian) {
                        return (
                            offsetX +
                            Math.cos(endRadian) * (1 + Math.cos(v) * k) * hoverRate
                        );
                    }
                    return offsetX + Math.cos(u) * (1 + Math.cos(v) * k) * hoverRate;
                },

                y: function (u, v) {
                    if (u < startRadian) {
                        return (
                            offsetY +
                            Math.sin(startRadian) * (1 + Math.cos(v) * k) * hoverRate
                        );
                    }
                    if (u > endRadian) {
                        return (
                            offsetY +
                            Math.sin(endRadian) * (1 + Math.cos(v) * k) * hoverRate
                        );
                    }
                    return offsetY + Math.sin(u) * (1 + Math.cos(v) * k) * hoverRate;
                },

                z: function (u, v) {
                    if (u < -Math.PI * 0.5) {
                        return Math.sin(u);
                    }
                    if (u > Math.PI * 2.5) {
                        return Math.sin(u);
                    }
                    return Math.sin(v) > 0 ? 1 * height : -1;
                },
            };
        },
        getPie3D(pieData, internalDiameterRatio) {
            let series = [];
            let sumValue = 0;
            let startValue = 0;
            let endValue = 0;
            let legendData = [];
            let k =
                typeof internalDiameterRatio !== "undefined"
                    ? (1 - internalDiameterRatio) / (1 + internalDiameterRatio)
                    : 1 / 3;

            // 为每一个饼图数据，生成一个 series-surface 配置
            for (let i = 0; i < pieData.length; i++) {
                sumValue += pieData[i].value;

                let seriesItem = {
                    name:
                        typeof pieData[i].name === "undefined"
                            ? `series${i}`
                            : pieData[i].name,
                    type: "surface",
                    parametric: true,
                    wireframe: {
                        show: false,
                    },
                    pieData: pieData[i],
                    emphasis: {
                        scale: false
                    },
                    scene: {
                        rotatable: false // 禁止旋转
                    },
                    roam: false,
                    pieStatus: {
                        selected: false,
                        hovered: false,
                        k: k,
                    },
                };

                if (typeof pieData[i].itemStyle != "undefined") {
                    let itemStyle = {};

                    typeof pieData[i].itemStyle.color != "undefined"
                        ? (itemStyle.color = pieData[i].itemStyle.color)
                        : null;
                    typeof pieData[i].itemStyle.opacity != "undefined"
                        ? (itemStyle.opacity = pieData[i].itemStyle.opacity)
                        : null;

                    seriesItem.itemStyle = itemStyle;
                }
                series.push(seriesItem);
            }

            // 使用上一次遍历时，计算出的数据和 sumValue，调用 getParametricEquation 函数，
            // 向每个 series-surface 传入不同的参数方程 series-surface.parametricEquation，也就是实现每一个扇形。
            for (let i = 0; i < series.length; i++) {
                endValue = startValue + series[i].pieData.value;
                series[i].pieData.startRatio = startValue / sumValue;
                series[i].pieData.endRatio = endValue / sumValue;
                series[i].parametricEquation = this.getParametricEquation(
                    series[i].pieData.startRatio,
                    series[i].pieData.endRatio,
                    false,
                    false,
                    k,
                    // 调整扇形高度
                    i === 0 ? 10 : 10,
                    i,
                    series[i].pieData.value
                );

                startValue = endValue;

                legendData.push(series[i].name);
            }
            return series;
        }

    }
}
</script>

<style lang="less" scoped>
.pieItem {
    width: 33.33%;
    margin-bottom: 10px;
    
}

.title {
    font-weight: bold;
    font-size: 14px;
    color: #FFFFFF;
    line-height: 16px;
    display: block;
    text-align: center;
    margin-top: 10px;
}


.itembox {
    margin-top: 20px;
    flex: 1;
    display: flex;
    flex-wrap: wrap;
    padding-right: 30px;
    .items {
        display: flex;
        align-items: center;
        flex-shrink: 1;
        width: 100%;
        margin-bottom: 10px;

        .bc {
            width: 16px;
            height: 6px;
            margin-right: 2px;
        }

        .itxt {
            display: flex;
            align-items: center;

            span {
                font-weight: 400;
                font-size: 12px;
                color: #FFFFFF;
            }

            .s1 {
                width: 100%;
                overflow: hidden;
                text-wrap: nowrap;
            }

        }
    }
}
</style>